Search results

Adding Header and Footer in JavaScript (ES5) Grid control

06 Jun 2023 / 4 minutes to read

You can customize text, page number, line, page size and changing orientation in header and footer.

You can add text either in Header or Footer of exported PDF document.

Copied to clipboard
let exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Text',
                value: "Northwind Traders",
                position: { x: 0, y: 50 },
                style: { textBrushColor: '#000000', fontSize: 13 }
            },

        ]
    }

you can add line either in Header or Footer of the exported PDF document.

Supported line styles:

  • dash
  • dot
  • dashdot
  • dashdotdot
  • solid
Copied to clipboard
let exportProperties: PdfExportProperties = {
header: {
    fromTop: 0,
    height: 130,
    contents: [
        {
            type: 'Line',
            style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
            points: { x1: 0, y1: 4, x2: 685, y2: 4 }
        }
    ]
}
}

you can add page number either in Header or Footer of exported PDF document.

Supported page number types:

  • LowerLatin - a, b, c,
  • UpperLatin - A, B, C,
  • LowerRoman - i, ii, iii,
  • UpperRoman - I, II, III,
  • Number - 1,2,3.
Copied to clipboard
 let exportProperties: PdfExportProperties = {
header: {
    fromTop: 0,
    height: 130,
    contents: [
        {
            type: 'PageNumber',
            pageNumberType: 'Arabic',
            format: 'Page {$current} of {$total}', //optional
            position: { x: 0, y: 25 },
            style: { textBrushColor: '#ffff80', fontSize: 15, hAlign: 'Center' }
        }
    ]
}
}

Image (Base64 string) can be added in the exported document in header/footer using the exportProperties.

Copied to clipboard
let exportProperties: PdfExportProperties = {
header: {
    fromTop: 0,
    height: 130,
    contents: [
        {
            type: 'Image',
            src: image,
            position: { x: 40, y: 10 },
            size: { height: 100, width: 250 },
        }
    ]
}
}

The below code illustrates the pdf export customization.

Source
Preview
index.js
index.html
Copied to clipboard
ej.grids.Grid.Inject(ej.grids.PdfExport, ej.grids.Page, ej.grids.Toolbar);
var image = "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";
var grid = new ej.grids.Grid({
    dataSource: data,
    allowPaging: true,
    allowPdfExport: true,
    toolbar: ['PdfExport'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 120, type: 'number' },
        { field: 'CustomerID', width: 140, headerText: 'Customer ID', type: 'string' },
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', width: 120, format: 'C' },
        { field: 'OrderDate', headerText: 'Order Date', textAlign: 'Right', width: 140, format: 'yMd' }
    ],
    height: 260
});
grid.appendTo('#Grid');
grid.toolbarClick= function(args){
    if (args['item'].id === 'Grid_pdfexport') {
        var pdfExportProperties = {
            header: {
                fromTop: 0,
                height: 130,
                contents: [
                    {
                        type: 'Image',
                        src: image,
                        position: { x: 40, y: 10 },
                        size: { height: 100, width: 250 },
                    }
                ]
            },
            footer: {
                fromBottom: 160,
                height: 150,
                contents: [
                    {
                        type: 'PageNumber',
                        pageNumberType: 'Arabic',
                        format: 'Page {$current} of {$total}',
                        position: { x: 0, y: 25 },
                        style: { textBrushColor: '#ffff80', fontSize: 15 }
                    }
                ]
            }
        };
        grid.pdfExport(pdfExportProperties);
    }
}
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-notifications/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-splitbuttons/styles/material.css" rel="stylesheet">

    
    
    <style>
        .e-row[aria-selected="true"] .e-customizedExpandcell {
            background-color: #e0e0e0;
        }
        .e-grid.e-gridhover tr[role='row']:hover {
            background-color: #eee;
        }
        .e-expand::before {
        content: '\e5b8';
    }
    .empImage {
        margin: 6px 16px;
        float: left;
        width: 50px;
        height: 50px;
    }
    </style>
<script src="https://cdn.syncfusion.com/ej2/21.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Repeat column header on every page

By default, column header will be placed on the first page of the pdf document but you can display column header on every page using repeatHeader property of pdfGrid.

In the below sample, we have enabled repeatHeader property in pdfHeaderQueryCellInfo event to show the header on every page.

Source
Preview
index.js
index.html
Copied to clipboard
ej.grids.Grid.Inject(ej.grids.Page, ej.grids.PdfExport, ej.grids.Toolbar);
var grid = new ej.grids.Grid({
    dataSource: purchaseData,
    allowPaging: true,
    allowPdfExport: true,
    toolbar: ['PdfExport'],
    columns: [
        { field: 'OrderID', headerText: 'Order ID', textAlign: 'Right', width: 120},
        { field: 'CustomerID', width: 140, headerText: 'Customer ID'},
        { field: 'Freight', headerText: 'Freight', textAlign: 'Right', width: 120, format: 'C' },
        { field: 'ShipName', headerText: 'ShipName', textAlign: 'Right', width: 140 }
    ],
    height: 260
});
grid.appendTo('#Grid');

grid.toolbarClick = function(args) {
    if (args['item'].id === 'Grid_pdfexport') {
        grid.pdfExport();
    }
}

grid.pdfHeaderQueryCellInfo = function(args){
    args.cell.row.pdfGrid.repeatHeader = true;
}
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>EJ2 Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-grids/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-richtexteditor/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-navigations/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-dropdowns/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-lists/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-calendars/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-notifications/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-splitbuttons/styles/material.css" rel="stylesheet">

    
    
    <style>
        .e-row[aria-selected="true"] .e-customizedExpandcell {
            background-color: #e0e0e0;
        }
        .e-grid.e-gridhover tr[role='row']:hover {
            background-color: #eee;
        }
        .e-expand::before {
        content: '\e5b8';
    }
    .empImage {
        margin: 6px 16px;
        float: left;
        width: 50px;
        height: 50px;
    }
    </style>
<script src="https://cdn.syncfusion.com/ej2/21.2.3/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div id="Grid"></div>
    </div>

<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Adding header and footer in Vue Grid component

11 Jun 202424 minutes to read

The Syncfusion Vue Grid allows you to add customized header and footer sections in the exported PDF document. This feature enables you to include custom text, page numbers, lines, page size, and even change the orientation of the header and footer.

To quickly get started with PDF export Options, you can refer to this video:

The Syncfusion Vue Grid allows you to add custom text in the header or footer section in the exported PDF document.

The header section of a PDF document is typically located at the top of each page. It’s a space where you can include additional information or branding elements. This is particularly useful for adding details like a company logo, a title for the document, a date, or any other information that you want to appear consistently on every page of the PDF.

The footer section, on the other hand, is usually positioned at the bottom of each page in the PDF. It’s another area where you can insert custom text. Common content in the footer includes page numbers, copyright information, or disclaimers. Similar to the header, the footer content is repeated on every page.

To add text in the header or footer of the exported PDF document, follow these steps:

  1. Access the pdfExportProperties of the Grid component.
  2. Set the header or footer property to a string value representing the desired text.
  3. Trigger the PDF export operation.

The following code example demostrates how to add the header in the exported PDF document.

let pdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
              type: 'Text',
              value: 'Exported Document Of Customers',
              position: { x:200, y: 50 },
              style: { textBrushColor: '#000000', fontSize: 20 },
            },
        ]
    }
}

When exporting data from the Syncfusion Vue Grid to a PDF document, you have an option to add a line in the header and footer section. This feature allows you to enhance the visual appearance of the exported PDF document and create a clear separation between the header and the content.

This can be achieved using the pdfExportProperties property of the Grid. You can customize the line style using different supported line styles listed below:

  • Dash
  • Dot
  • DashDot
  • DashDotDot
  • Solid

To add a line in the header or footer of the exported PDF document, you can access the header.contents or footer.contents property of the header or footer in the pdfExportProperties property of the grid.

The following code example demostrates how to draw a line in the header of the exported PDF document.

let pdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            }
        ]
    }
    footer: {
        fromBottom: 10,
        height: 60,
        contents: [
            {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
        ],
    },
}

When exporting data from the Syncfusion Vue Grid to a PDF document, you have an option to include page numbers in the header and footer section. This feature allows you to provide a reference to the page number for better document navigation.

This can be achieved using the pdfExportProperties property of the Grid. You can choose from different types of supported page number listed below:

  • LowerLatin - a, b, c,
  • UpperLatin - A, B, C,
  • LowerRoman - i, ii, iii,
  • UpperRoman - I, II, III,
  • Number - 1,2,3,
  • Arabic - 1,2,3.

To add a page number in the header or footer of the exported PDF document, you can access the header.contents or footer.contents property of the header or footer in the pdfExportProperties property of the grid.

The following code example demostrates how to add a page number in the footer of the exported PDF document.

 let pdfExportProperties = {
    footer: {
        fromBottom: 10,
        height: 60,
        contents: [
            {
                type: 'PageNumber',
                pageNumberType: 'Arabic',
                format: 'Page {$current} of {$total}', //optional
                position: { x: 0, y: 25 },
                style: { textBrushColor: '#4169e1', fontSize: 15, hAlign: 'Center' }
            }
        ]
    }
}

The Syncfusion Vue Grid have an option to include an image in the header and footer section when exporting data from the Grid to PDF document. This feature allows you to add a custom logo, branding, or any other relevant image to the exported document.

You can use a base64 string with the .jpeg format to represent the image. This can be achieved using the pdfExportProperties property of the Grid component.

To insert an image in the header or footer of the exported PDF document, follow these steps:

  1. Convert your desired image to a base64 string in the .jpeg format.

  2. Access the pdfExportProperties of the Grid component.

  3. Set the header.contents.src property to the respective file of the image or the base64 string of the image.

  4. Trigger the PDF export operation.

let pdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Image',
                src: image,
                position: { x: 40, y: 10 },
                size: { height: 100, width: 150 },
            }
        ]
    }
}

The following example demonstrates how to add a header and footer to the exported grid. In the given example, we added lines in the header and footer, inserted an image in the header, and also added page number in the footer.

<template>
  <div id="app">
    <ejs-grid ref='grid' id='Grid' :dataSource='data' :toolbar='toolbarOptions' height='272px' :allowPdfExport='true' :toolbarClick='toolbarClick'>
      <e-columns>
        <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=90></e-column>
        <e-column field='CustomerID' headerText='Customer ID' width=100></e-column>
        <e-column field='ShipCity' headerText='Ship City' width=100></e-column>
        <e-column field='ShipName' headerText='Ship Name' width=120></e-column>
      </e-columns>
    </ejs-grid>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Toolbar, PdfExport } from "@syncfusion/ej2-vue-grids";
import { data } from './datasource.js';
import { image } from './image.js';
const grid = ref(null);
      const toolbarOptions = ['PdfExport'];
    const toolbarClick = (args) => {
      if (args.item.id === 'Grid_pdfexport') { // 'Grid_pdfexport' -> Grid component id + _ + toolbar item name
        let pdfExportProperties = {
          header: {
            fromTop: 0,
            height: 130,
            contents: [
              {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
              },
              {
                type: 'Text',
                value: 'Exported Document Of Customers',
                position: { x: 200, y: 50 },
                style: { textBrushColor: '#000000', fontSize: 20 },
              },
              {
                type: 'Image',
                src: image,
                position: { x: 40, y: 10 },
                size: { height: 100, width: 150 },
              },
            ],
          },
          footer: {
            fromBottom: 10,
            height: 60,
            contents: [
              {
                type: 'PageNumber',
                pageNumberType: 'Arabic',
                format: 'Page {$current} of {$total}', //optional
                position: { x: 0, y: 25 },
                style: {
                  textBrushColor: '#4169e1',
                  fontSize: 15,
                  hAlign: 'Center',
                },
              },
              {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
              },
            ],
          },
        };
        grid.value.pdfExport(pdfExportProperties);
      }
    }
  provide('grid',  [Toolbar, PdfExport]);
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
</style>
<template>
  <div id="app">
    <ejs-grid ref='grid' id='Grid' :dataSource='data' :toolbar='toolbarOptions' height='272px' :allowPdfExport='true' :toolbarClick='toolbarClick'>
      <e-columns>
        <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=90></e-column>
        <e-column field='CustomerID' headerText='Customer ID' width=100></e-column>
        <e-column field='ShipCity' headerText='Ship City' width=100></e-column>
        <e-column field='ShipName' headerText='Ship Name' width=120></e-column>
      </e-columns>
    </ejs-grid>
  </div>
</template>
<script>

import { GridComponent, ColumnsDirective, ColumnDirective, Toolbar, PdfExport } from "@syncfusion/ej2-vue-grids";
import { data } from './datasource.js';
import { image } from './image.js';
export default {
name: "App",
components: {
"ejs-grid":GridComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data() {
    return {
      data: data,
      toolbarOptions: ['PdfExport']
    };
  },
  methods: {
    toolbarClick(args) {
      if (args.item.id === 'Grid_pdfexport') { // 'Grid_pdfexport' -> Grid component id + _ + toolbar item name
        let pdfExportProperties = {
          header: {
            fromTop: 0,
            height: 130,
            contents: [
              {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
              },
              {
                type: 'Text',
                value: 'Exported Document Of Customers',
                position: { x: 200, y: 50 },
                style: { textBrushColor: '#000000', fontSize: 20 },
              },
              {
                type: 'Image',
                src: image,
                position: { x: 40, y: 10 },
                size: { height: 100, width: 150 },
              },
            ],
          },
          footer: {
            fromBottom: 10,
            height: 60,
            contents: [
              {
                type: 'PageNumber',
                pageNumberType: 'Arabic',
                format: 'Page {$current} of {$total}', //optional
                position: { x: 0, y: 25 },
                style: {
                  textBrushColor: '#4169e1',
                  fontSize: 15,
                  hAlign: 'Center',
                },
              },
              {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
              },
            ],
          },
        };
        this.$refs.grid.pdfExport(pdfExportProperties);
      }
    }
  },
  provide: {
    grid: [Toolbar, PdfExport]
  }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
</style>

Repeat column header on every page

When exporting data from the Syncfusion Vue Grid to a PDF document, you have an option to repeat the column header on every page. This feature ensures that the column header remains visible and easily identifiable, even when the data spans multiple pages in the exported PDF document.

By default, the column header is occurs only on the first page of the PDF document. However, you can enable the repeatHeader property of the pdfGrid object to true which display the column header on every page. This can be achieved using the pdfHeaderQueryCellInfo event of the Grid.

The following example demonstrates how to repeat the column header on every page of the exported PDF document using the pdfHeaderQueryCellInfo event.

<template>
  <div id="app">
    <ejs-grid ref='grid' id='Grid' :dataSource='data' :toolbar='toolbarOptions' height='272px' :allowPdfExport='true' :pdfHeaderQueryCellInfo='pdfHeaderQueryCellInfo' :toolbarClick='toolbarClick'>
      <e-columns>
        <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=90></e-column>
        <e-column field='CustomerID' headerText='Customer ID' width=100></e-column>
        <e-column field='Freight' headerText='Freight' width=80></e-column>
        <e-column field='ShipName' headerText='Ship Name' width=120></e-column>
      </e-columns>
    </ejs-grid>
  </div>
</template>
<script setup>
import { provide, ref } from "vue";
import { GridComponent as EjsGrid, ColumnDirective as EColumn, ColumnsDirective as EColumns, Toolbar, PdfExport } from "@syncfusion/ej2-vue-grids";
import { purchaseData } from './datasource.js';
const grid = ref(null);
      const data = purchaseData;
      const toolbarOptions = ['PdfExport'];
    const toolbarClick = (args) => {
      if (args.item.id === 'Grid_pdfexport') {
        grid.value.pdfExport();
      }
    }
    const pdfHeaderQueryCellInfo = (args) => {
      args.cell.row.pdfGrid.repeatHeader = true;
    }
  provide('grid',  [Toolbar, PdfExport]);
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
</style>
<template>
  <div id="app">
    <ejs-grid ref='grid' id='Grid' :dataSource='data' :toolbar='toolbarOptions' height='272px' :allowPdfExport='true' :pdfHeaderQueryCellInfo='pdfHeaderQueryCellInfo' :toolbarClick='toolbarClick'>
      <e-columns>
        <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=90></e-column>
        <e-column field='CustomerID' headerText='Customer ID' width=100></e-column>
        <e-column field='Freight' headerText='Freight' width=80></e-column>
        <e-column field='ShipName' headerText='Ship Name' width=120></e-column>
      </e-columns>
    </ejs-grid>
  </div>
</template>
<script>

import { GridComponent, ColumnsDirective, ColumnDirective, Toolbar, PdfExport } from "@syncfusion/ej2-vue-grids";
import { purchaseData } from './datasource.js';
export default {
name: "App",
components: {
"ejs-grid":GridComponent,
"e-columns":ColumnsDirective,
"e-column":ColumnDirective
},
  data() {
    return {
      data: purchaseData,
      toolbarOptions: ['PdfExport']
    };
  },
  methods: {
    toolbarClick(args) {
      if (args.item.id === 'Grid_pdfexport') {
        this.$refs.grid.pdfExport();
      }
    },
    pdfHeaderQueryCellInfo(args) {
      args.cell.row.pdfGrid.repeatHeader = true;
    }
  },
  provide: {
    grid: [Toolbar, PdfExport]
  }
}
</script>
<style>
  @import "../node_modules/@syncfusion/ej2-base/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-buttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-calendars/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-dropdowns/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-inputs/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-popups/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind.css";
  @import "../node_modules/@syncfusion/ej2-vue-grids/styles/tailwind.css";
</style>

Adding header and footer in React Grid component

17 Mar 202524 minutes to read

The Syncfusion® React Grid allows you to add customized header and footer sections in the exported PDF document. This feature enables you to include custom text, page numbers, lines, page size, and even change the orientation of the header and footer.

The Syncfusion® React Grid allows you to add custom text in the header or footer section in the exported PDF document.

The header section of a PDF document is typically located at the top of each page. It’s a space where you can include additional information or branding elements. This is particularly useful for adding details like a company logo, a title for the document, a date, or any other information that you want to appear consistently on every page of the PDF.

The footer section, on the other hand, is usually positioned at the bottom of each page in the PDF. It’s another area where you can insert custom text. Common content in the footer includes page numbers, copyright information, or disclaimers. Similar to the header, the footer content is repeated on every page.

To add text in the header or footer of the exported PDF document, follow these steps:

  1. Access the pdfExportProperties of the Grid component.
  2. Set the header or footer property to a string value representing the desired text.
  3. Trigger the PDF export operation.

The following code example demostrates how to add the header in the exported PDF document.

const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
              type: 'Text',
              value: 'Exported Document Of Customers',
              position: { x:200, y: 50 },
              style: { textBrushColor: '#000000', fontSize: 20 },
            },
        ]
    }

When exporting data from the Syncfusion® React Grid to a PDF document, you have an option to add a line in the header and footer section. This feature allows you to enhance the visual appearance of the exported PDF document and create a clear separation between the header and the content.

This can be achieved using the pdfExportProperties property of the Grid. You can customize the line style using different supported line styles listed below:

  • Dash
  • Dot
  • DashDot
  • DashDotDot
  • Solid

To add a line in the header or footer of the exported PDF document, you can access the header.contents or footer.contents property of the header or footer in the pdfExportProperties property of the grid.

The following code example demostrates how to draw a line in the header of the exported PDF document.

const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            }
        ]
    }
    footer: {
        fromBottom: 10,
        height: 60,
        contents: [
            {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
        ],
    },
}

When exporting data from the Syncfusion® React Grid to a PDF document, you have an option to include page numbers in the header and footer section. This feature allows you to provide a reference to the page number for better document navigation.

This can be achieved using the pdfExportProperties property of the Grid. You can choose from different types of supported page number listed below:

  • LowerLatin - a, b, c,
  • UpperLatin - A, B, C,
  • LowerRoman - i, ii, iii,
  • UpperRoman - I, II, III,
  • Number - 1,2,3,
  • Arabic - 1,2,3.

To add a page number in the header or footer of the exported PDF document, you can access the header.contents or footer.contents property of the header or footer in the pdfExportProperties property of the grid.

The following code example demostrates how to add a page number in the footer of the exported PDF document.

 const exportProperties: PdfExportProperties = {
    footer: {
        fromBottom: 10,
        height: 60,
        contents: [
            {
                type: 'PageNumber',
                pageNumberType: 'Arabic',
                format: 'Page {$current} of {$total}', //optional
                position: { x: 0, y: 25 },
                style: { textBrushColor: '#4169e1', fontSize: 15, hAlign: 'Center' }
            }
        ]
    }
}

The Syncfusion® React Grid have an option to include an image in the header and footer section when exporting data from the Grid to PDF document. This feature allows you to add a custom logo, branding, or any other relevant image to the exported document.

You can use a base64 string with the .jpeg format to represent the image. This can be achieved using the pdfExportProperties property of the Grid component.

To insert an image in the header or footer of the exported PDF document, follow these steps:

  1. Convert your desired image to a base64 string in the .jpeg format.

  2. Access the pdfExportProperties of the Grid component.

  3. Set the header.contents.src property to the respective file of the image or the base64 string of the image.

  4. Trigger the PDF export operation.

const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
              type: 'Image',
              src: image,
              position: { x: 40, y: 10 },
              size: { height: 100, width: 150 },
            },
        ]
    }
}

The following example demonstrates how to add a header and footer to the exported grid. In the given example, we added lines in the header and footer, inserted an image in the header, and also added page number in the footer.

import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';
import { Inject, PdfExport, Toolbar, Page } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
import { image } from './image';

function App() {
  let grid;
  const toolbar = ['PdfExport'];
  const toolbarClick = (args) => {
    if (args.item.id === 'Grid_pdfexport') {
      const pdfExportProperties = {
        footer: {
          contents: [
            {
              format: 'Page {$current} of {$total}', //optional
              pageNumberType: 'Arabic',
              position: { x: 0, y: 25 },
              style: {
                fontSize: 15,
                textBrushColor: '#4169e1',
                hAlign: 'Center'
              },
              type: 'PageNumber'
            },
            {
              type: 'Line',
              style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
              points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
          ],
          fromBottom: 160,
          height: 150
        },
        header: {
          contents: [
            {
              type: 'Line',
              style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
              points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
            {
              type: 'Text',
              value: 'Exported Document Of Customers',
              position: { x: 200, y: 50 },
              style: { textBrushColor: '#000000', fontSize: 20 },
            },
            {
              type: 'Image',
              src: image,
              position: { x: 40, y: 10 },
              size: { height: 100, width: 150 },
            },
          ],
          fromTop: 0,
          height: 130
        }
      };
      if (grid) {
        grid.pdfExport(pdfExportProperties);
      }
    }
  }
  return (
    <div>
      <GridComponent id='Grid' dataSource={data} allowPaging={true} toolbar={toolbar} allowPdfExport={true}
        toolbarClick={toolbarClick} ref={g => grid = g}>
        <ColumnsDirective>
          <ColumnDirective field='OrderID' headerText='Order ID' width='120' textAlign='Right' />
          <ColumnDirective field='CustomerID' headerText='Customer ID' width='150' />
          <ColumnDirective field='ShipCity' headerText='Ship City' width='150' />
          <ColumnDirective field='ShipName' headerText='Ship Name' width='150' />
        </ColumnsDirective>
        <Inject services={[Toolbar, PdfExport, Page]} />
      </GridComponent>
    </div>
  );
}
export default App;
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, GridComponent, ToolbarItems } from '@syncfusion/ej2-react-grids';
import { Inject, PdfExport, PdfExportProperties, Toolbar, Page } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
import { image } from './image';

function App() {
  let grid: GridComponent | null;
  const toolbar: ToolbarItems[] = ['PdfExport'];
  const toolbarClick = (args: ClickEventArgs) => {
    if (args.item.id === 'Grid_pdfexport') {
      const pdfExportProperties: PdfExportProperties = {
        footer: {
          contents: [
            {
              format: 'Page {$current} of {$total}', //optional
              pageNumberType: 'Arabic',
              position: { x: 0, y: 25 },
              style: {
                fontSize: 15,
                textBrushColor: '#4169e1',
                hAlign: 'Center'
              },
              type: 'PageNumber'
            },
            {
              type: 'Line',
              style: { penColor: '#000080', penSize: 2, dashStyle: 'Dot' },
              points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
          ],
          fromBottom: 160,
          height: 150
        },
        header: {
          contents: [
            {
              type: 'Line',
              style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
              points: { x1: 0, y1: 4, x2: 685, y2: 4 },
            },
            {
              type: 'Text',
              value: 'Exported Document Of Customers',
              position: { x: 200, y: 50 },
              style: { textBrushColor: '#000000', fontSize: 20 },
            },
            {
              type: 'Image',
              src: image,
              position: { x: 40, y: 10 },
              size: { height: 100, width: 150 },
            },
          ],
          fromTop: 0,
          height: 130
        }
      };
      if (grid) {
        grid.pdfExport(pdfExportProperties);
      }
    }
  }
  return (
    <div>
      <GridComponent id='Grid' dataSource={data} allowPaging={true} toolbar={toolbar} allowPdfExport={true}
        toolbarClick={toolbarClick} ref={g => grid = g}>
        <ColumnsDirective>
          <ColumnDirective field='OrderID' headerText='Order ID' width='120' textAlign='Right' />
          <ColumnDirective field='CustomerID' headerText='Customer ID' width='150' />
          <ColumnDirective field='ShipCity' headerText='Ship City' width='150' />
          <ColumnDirective field='ShipName' headerText='Ship Name' width='150' />
        </ColumnsDirective>
        <Inject services={[Toolbar, PdfExport, Page]} />
      </GridComponent>
    </div>
  );
}
export default App;
export let data = [
    {
        OrderID: 10248, CustomerID: 'VINET', EmployeeID: 5, OrderDate: new Date(8364186e5),
        ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
        ShipRegion: 'CJ', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0
    },
    {
        OrderID: 10249, CustomerID: 'TOMSP', EmployeeID: 6, OrderDate: new Date(836505e6),
        ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
        ShipRegion: 'CJ', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1
    },
    {
        OrderID: 10250, CustomerID: 'HANAR', EmployeeID: 4, OrderDate: new Date(8367642e5),
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0
    },
    {
        OrderID: 10251, CustomerID: 'VICTE', EmployeeID: 3, OrderDate: new Date(8367642e5),
        ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
        ShipRegion: 'CJ', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0
    },
    {
        OrderID: 10252, CustomerID: 'SUPRD', EmployeeID: 4, OrderDate: new Date(8368506e5),
        ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
        ShipRegion: 'CJ', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0
    },
    {
        OrderID: 10253, CustomerID: 'HANAR', EmployeeID: 3, OrderDate: new Date(836937e6),
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0
    },
    {
        OrderID: 10254, CustomerID: 'CHOPS', EmployeeID: 5, OrderDate: new Date(8370234e5),
        ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
        ShipRegion: 'CJ', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1
    },
    {
        OrderID: 10255, CustomerID: 'RICSU', EmployeeID: 9, OrderDate: new Date(8371098e5),
        ShipName: 'Richter Supermarkt', ShipCity: 'Genève', ShipAddress: 'Starenweg 5',
        ShipRegion: 'CJ', ShipPostalCode: '1204', ShipCountry: 'Switzerland', Freight: 148.33, Verified: !0
    },
    {
        OrderID: 10256, CustomerID: 'WELLI', EmployeeID: 3, OrderDate: new Date(837369e6),
        ShipName: 'Wellington Importadora', ShipCity: 'Resende', ShipAddress: 'Rua do Mercado, 12',
        ShipRegion: 'SP', ShipPostalCode: '08737-363', ShipCountry: 'Brazil', Freight: 13.97, Verified: !1
    },
    {
        OrderID: 10257, CustomerID: 'HILAA', EmployeeID: 4, OrderDate: new Date(8374554e5),
        ShipName: 'HILARION-Abastos', ShipCity: 'San Cristóbal', ShipAddress: 'Carrera 22 con Ave. Carlos Soublette #8-35',
        ShipRegion: 'Táchira', ShipPostalCode: '5022', ShipCountry: 'Venezuela', Freight: 81.91, Verified: !0
    },
    {
        OrderID: 10258, CustomerID: 'ERNSH', EmployeeID: 1, OrderDate: new Date(8375418e5),
        ShipName: 'Ernst Handel', ShipCity: 'Graz', ShipAddress: 'Kirchgasse 6',
        ShipRegion: 'CJ', ShipPostalCode: '8010', ShipCountry: 'Austria', Freight: 140.51, Verified: !0
    },
    {
        OrderID: 10259, CustomerID: 'CENTC', EmployeeID: 4, OrderDate: new Date(8376282e5),
        ShipName: 'Centro comercial Moctezuma', ShipCity: 'México D.F.', ShipAddress: 'Sierras de Granada 9993',
        ShipRegion: 'CJ', ShipPostalCode: '05022', ShipCountry: 'Mexico', Freight: 3.25, Verified: !1
    },
    {
        OrderID: 10260, CustomerID: 'OTTIK', EmployeeID: 4, OrderDate: new Date(8377146e5),
        ShipName: 'Ottilies Käseladen', ShipCity: 'Köln', ShipAddress: 'Mehrheimerstr. 369',
        ShipRegion: 'CJ', ShipPostalCode: '50739', ShipCountry: 'Germany', Freight: 55.09, Verified: !0
    },
    {
        OrderID: 10261, CustomerID: 'QUEDE', EmployeeID: 4, OrderDate: new Date(8377146e5),
        ShipName: 'Que Delícia', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua da Panificadora, 12',
        ShipRegion: 'RJ', ShipPostalCode: '02389-673', ShipCountry: 'Brazil', Freight: 3.05, Verified: !1
    },
    {
        OrderID: 10262, CustomerID: 'RATTC', EmployeeID: 8, OrderDate: new Date(8379738e5),
        ShipName: 'Rattlesnake Canyon Grocery', ShipCity: 'Albuquerque', ShipAddress: '2817 Milton Dr.',
        ShipRegion: 'NM', ShipPostalCode: '87110', ShipCountry: 'USA', Freight: 48.29, Verified: !0
    }
];
export let data: Object[] = [
    {
        OrderID: 10248, CustomerID: 'VINET', EmployeeID: 5, OrderDate: new Date(8364186e5),
        ShipName: 'Vins et alcools Chevalier', ShipCity: 'Reims', ShipAddress: '59 rue de l Abbaye',
        ShipRegion: 'CJ', ShipPostalCode: '51100', ShipCountry: 'France', Freight: 32.38, Verified: !0
    },
    {
        OrderID: 10249, CustomerID: 'TOMSP', EmployeeID: 6, OrderDate: new Date(836505e6),
        ShipName: 'Toms Spezialitäten', ShipCity: 'Münster', ShipAddress: 'Luisenstr. 48',
        ShipRegion: 'CJ', ShipPostalCode: '44087', ShipCountry: 'Germany', Freight: 11.61, Verified: !1
    },
    {
        OrderID: 10250, CustomerID: 'HANAR', EmployeeID: 4, OrderDate: new Date(8367642e5),
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 65.83, Verified: !0
    },
    {
        OrderID: 10251, CustomerID: 'VICTE', EmployeeID: 3, OrderDate: new Date(8367642e5),
        ShipName: 'Victuailles en stock', ShipCity: 'Lyon', ShipAddress: '2, rue du Commerce',
        ShipRegion: 'CJ', ShipPostalCode: '69004', ShipCountry: 'France', Freight: 41.34, Verified: !0
    },
    {
        OrderID: 10252, CustomerID: 'SUPRD', EmployeeID: 4, OrderDate: new Date(8368506e5),
        ShipName: 'Suprêmes délices', ShipCity: 'Charleroi', ShipAddress: 'Boulevard Tirou, 255',
        ShipRegion: 'CJ', ShipPostalCode: 'B-6000', ShipCountry: 'Belgium', Freight: 51.3, Verified: !0
    },
    {
        OrderID: 10253, CustomerID: 'HANAR', EmployeeID: 3, OrderDate: new Date(836937e6),
        ShipName: 'Hanari Carnes', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua do Paço, 67',
        ShipRegion: 'RJ', ShipPostalCode: '05454-876', ShipCountry: 'Brazil', Freight: 58.17, Verified: !0
    },
    {
        OrderID: 10254, CustomerID: 'CHOPS', EmployeeID: 5, OrderDate: new Date(8370234e5),
        ShipName: 'Chop-suey Chinese', ShipCity: 'Bern', ShipAddress: 'Hauptstr. 31',
        ShipRegion: 'CJ', ShipPostalCode: '3012', ShipCountry: 'Switzerland', Freight: 22.98, Verified: !1
    },
    {
        OrderID: 10255, CustomerID: 'RICSU', EmployeeID: 9, OrderDate: new Date(8371098e5),
        ShipName: 'Richter Supermarkt', ShipCity: 'Genève', ShipAddress: 'Starenweg 5',
        ShipRegion: 'CJ', ShipPostalCode: '1204', ShipCountry: 'Switzerland', Freight: 148.33, Verified: !0
    },
    {
        OrderID: 10256, CustomerID: 'WELLI', EmployeeID: 3, OrderDate: new Date(837369e6),
        ShipName: 'Wellington Importadora', ShipCity: 'Resende', ShipAddress: 'Rua do Mercado, 12',
        ShipRegion: 'SP', ShipPostalCode: '08737-363', ShipCountry: 'Brazil', Freight: 13.97, Verified: !1
    },
    {
        OrderID: 10257, CustomerID: 'HILAA', EmployeeID: 4, OrderDate: new Date(8374554e5),
        ShipName: 'HILARION-Abastos', ShipCity: 'San Cristóbal', ShipAddress: 'Carrera 22 con Ave. Carlos Soublette #8-35',
        ShipRegion: 'Táchira', ShipPostalCode: '5022', ShipCountry: 'Venezuela', Freight: 81.91, Verified: !0
    },
    {
        OrderID: 10258, CustomerID: 'ERNSH', EmployeeID: 1, OrderDate: new Date(8375418e5),
        ShipName: 'Ernst Handel', ShipCity: 'Graz', ShipAddress: 'Kirchgasse 6',
        ShipRegion: 'CJ', ShipPostalCode: '8010', ShipCountry: 'Austria', Freight: 140.51, Verified: !0
    },
    {
        OrderID: 10259, CustomerID: 'CENTC', EmployeeID: 4, OrderDate: new Date(8376282e5),
        ShipName: 'Centro comercial Moctezuma', ShipCity: 'México D.F.', ShipAddress: 'Sierras de Granada 9993',
        ShipRegion: 'CJ', ShipPostalCode: '05022', ShipCountry: 'Mexico', Freight: 3.25, Verified: !1
    },
    {
        OrderID: 10260, CustomerID: 'OTTIK', EmployeeID: 4, OrderDate: new Date(8377146e5),
        ShipName: 'Ottilies Käseladen', ShipCity: 'Köln', ShipAddress: 'Mehrheimerstr. 369',
        ShipRegion: 'CJ', ShipPostalCode: '50739', ShipCountry: 'Germany', Freight: 55.09, Verified: !0
    },
    {
        OrderID: 10261, CustomerID: 'QUEDE', EmployeeID: 4, OrderDate: new Date(8377146e5),
        ShipName: 'Que Delícia', ShipCity: 'Rio de Janeiro', ShipAddress: 'Rua da Panificadora, 12',
        ShipRegion: 'RJ', ShipPostalCode: '02389-673', ShipCountry: 'Brazil', Freight: 3.05, Verified: !1
    },
    {
        OrderID: 10262, CustomerID: 'RATTC', EmployeeID: 8, OrderDate: new Date(8379738e5),
        ShipName: 'Rattlesnake Canyon Grocery', ShipCity: 'Albuquerque', ShipAddress: '2817 Milton Dr.',
        ShipRegion: 'NM', ShipPostalCode: '87110', ShipCountry: 'USA', Freight: 48.29, Verified: !0
    }];

Repeat column header on every page

When exporting data from the Syncfusion® React Grid to a PDF document, you have an option to repeat the column header on every page. This feature ensures that the column header remains visible and easily identifiable, even when the data spans multiple pages in the exported PDF document.

By default, the column header is occurs only on the first page of the PDF document. However, you can enable the repeatHeader property of the pdfGrid object to true which display the column header on every page. This can be achieved using the pdfHeaderQueryCellInfo event of the Grid.

The following example demonstrates how to repeat the column header on every page of the exported PDF document using the pdfHeaderQueryCellInfo event.

import { ColumnDirective, ColumnsDirective, GridComponent } from '@syncfusion/ej2-react-grids';
import { Inject, PdfExport, Toolbar } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';
function App() {
    let grid;
    const toolbar = ['PdfExport'];
    const toolbarClick = (args) => {
        if (grid && args.item.id === 'Grid_pdfexport') {
            grid.pdfExport();
        }
    };
    const pdfHeaderQueryCellInfo = (args) => {
        args.cell.row.pdfGrid.repeatHeader = true;
    };
    return (<div>
        <GridComponent id='Grid' dataSource={data} height={315} toolbar={toolbar} allowPdfExport={true} toolbarClick={toolbarClick} pdfHeaderQueryCellInfo={pdfHeaderQueryCellInfo} ref={g => grid = g}>
            <ColumnsDirective>
                <ColumnDirective field='OrderID' headerText='Order ID' width='120' textAlign='Right' />
                <ColumnDirective field='CustomerID' headerText='Customer ID' width='150' />
                <ColumnDirective field='Freight' headerText='Freight' width='100' />
                <ColumnDirective field='ShipName' headerText='Ship Name' width='150' />
            </ColumnsDirective>
            <Inject services={[Toolbar, PdfExport]} />
        </GridComponent>
    </div>);
}
export default App;
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { ColumnDirective, ColumnsDirective, GridComponent, ToolbarItems } from '@syncfusion/ej2-react-grids';
import { Inject, PdfExport, PdfHeaderQueryCellInfoEventArgs, Toolbar } from '@syncfusion/ej2-react-grids';
import * as React from 'react';
import { data } from './datasource';

function App() {
  let grid: GridComponent | null;
  const toolbar: ToolbarItems[] = ['PdfExport'];
  const toolbarClick = (args: ClickEventArgs) => {
    if (grid && args.item.id === 'Grid_pdfexport') {
      grid.pdfExport();
    }
  }
  const pdfHeaderQueryCellInfo = (args: PdfHeaderQueryCellInfoEventArgs): void => {
     (args.cell as any).row.pdfGrid.repeatHeader = true;
  }
    return (
      <div>
        <GridComponent id='Grid' dataSource={data} height={315} toolbar={toolbar}
        allowPdfExport={true} toolbarClick={toolbarClick}
        pdfHeaderQueryCellInfo={pdfHeaderQueryCellInfo} ref={g=> grid = g}>
        <ColumnsDirective>
            <ColumnDirective field='OrderID' headerText='Order ID' width='120' textAlign='Right'/>
            <ColumnDirective field='CustomerID' headerText='Customer ID' width='150' />
            <ColumnDirective field='Freight' headerText='Freight' width='100' />
            <ColumnDirective field='ShipName' headerText='Ship Name' width='150' />
        </ColumnsDirective>
        <Inject services={[Toolbar, PdfExport]}/>
      </GridComponent>
    </div>
    );
}
export default App;
export let data = [
    {
        'OrderID': 10248,
        'CustomerID': 'VINET',
        'OrderDate': '1996-07-04T10:10:00.000Z',
        'ShippedDate': '1996-07-16T12:20:00.000Z',
        'Freight': 32.38,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10249,
        'CustomerID': 'TOMSP',
        'OrderDate': '1996-07-05T12:20:00.000Z',
        'ShippedDate': '1996-07-10T13:20:00.000Z',
        'Freight': 11.61,
        'ShipName': 'Toms Spezialitäten',
        'ShipAddress': 'Luisenstr. 48',
        'ShipCity': 'Münster',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10250,
        'CustomerID': 'HANAR',
        'OrderDate': '1996-07-08T08:40:00.000Z',
        'ShippedDate': '1996-07-12T07:50:00.000Z',
        'Freight': 65.83,
        'ShipName': 'Hanari Carnes',
        'ShipAddress': 'Rua do Paço, 67',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10251,
        'CustomerID': 'VICTE',
        'OrderDate': '1996-07-08T07:50:00.000Z',
        'ShippedDate': '1996-07-15T15:50:00.000Z',
        'Freight': 41.34,
        'ShipName': 'Victuailles en stock',
        'ShipAddress': '2, rue du Commerce',
        'ShipCity': 'Lyon',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10252,
        'CustomerID': 'SUPRD',
        'OrderDate': '1996-07-09T12:05:00.000Z',
        'ShippedDate': '1996-07-11T17:30:00.000Z',
        'Freight': 51.3,
        'ShipName': 'Suprêmes délices',
        'ShipAddress': 'Boulevard Tirou, 255',
        'ShipCity': 'Charleroi',
        'ShipRegion': null,
        'ShipCountry': 'Belgium'
    },
    {
        'OrderID': 10253,
        'CustomerID': 'HANAR',
        'OrderDate': '1996-07-10T11:20:00.000Z',
        'ShippedDate': '1996-07-16T10:10:00.000Z',
        'Freight': 58.17,
        'ShipName': 'Hanari Carnes',
        'ShipAddress': 'Rua do Paço, 67',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10254,
        'CustomerID': 'CHOPS',
        'OrderDate': '1996-07-11T10:00.00.000Z',
        'ShippedDate': '1996-07-23T20:40:00.000Z',
        'Freight': 22.98,
        'ShipName': 'Chop-suey Chinese',
        'ShipAddress': 'Hauptstr. 31',
        'ShipCity': 'Bern',
        'ShipRegion': null,
        'ShipCountry': 'Switzerland'
    },
    {
        'OrderID': 10255,
        'CustomerID': 'RICSU',
        'OrderDate': '1996-07-12T10:40:00.000Z',
        'ShippedDate': '1996-07-15T05:40:00.000Z',
        'Freight': 148.33,
        'ShipName': 'Richter Supermarkt',
        'ShipAddress': 'Starenweg 5',
        'ShipCity': 'Genève',
        'ShipRegion': null,
        'ShipCountry': 'Switzerland'
    },
    {
        'OrderID': 10256,
        'CustomerID': 'WELLI',
        'OrderDate': '1996-07-15T20:50:00.000Z',
        'ShippedDate': '1996-07-17T21:50:00.000Z',
        'Freight': 13.97,
        'ShipName': 'Wellington Importadora',
        'ShipAddress': 'Rua do Mercado, 12',
        'ShipCity': 'Resende',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10257,
        'CustomerID': 'HILAA',
        'OrderDate': '1996-07-16T03:20:00.000Z',
        'ShippedDate': '1996-07-22T14:40:00.000Z',
        'Freight': 81.91,
        'ShipName': 'HILARION-Abastos',
        'ShipAddress': 'Carrera 22 con Ave. Carlos Soublette #8-35',
        'ShipCity': 'San Cristóbal',
        'ShipRegion': 'Táchira',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10258,
        'CustomerID': 'ERNSH',
        'OrderDate': '1996-07-17T18:30:00.000Z',
        'ShippedDate': '1996-07-23T14:50:00.000Z',
        'Freight': 140.51,
        'ShipName': 'Ernst Handel',
        'ShipAddress': 'Kirchgasse 6',
        'ShipCity': 'Graz',
        'ShipRegion': null,
        'ShipCountry': 'Austria'
    },
    {
        'OrderID': 10259,
        'CustomerID': 'CENTC',
        'OrderDate': '1996-07-18T01:20:00.000Z',
        'ShippedDate': '1996-07-25T16:20:00.000Z',
        'Freight': 3.25,
        'ShipName': 'Centro comercial Moctezuma',
        'ShipAddress': 'Sierras de Granada 9993',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10260,
        'CustomerID': 'OTTIK',
        'OrderDate': '1996-07-19T11:20:00.000Z',
        'ShippedDate': '1996-07-29T03:10:00.000Z',
        'Freight': 55.09,
        'ShipName': 'Ottilies Käseladen',
        'ShipAddress': 'Mehrheimerstr. 369',
        'ShipCity': 'Köln',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10261,
        'CustomerID': 'QUEDE',
        'OrderDate': '1996-07-19T18:30:00.000Z',
        'ShippedDate': '1996-07-30T23:10:00.000Z',
        'Freight': 3.05,
        'ShipName': 'Que Delícia',
        'ShipAddress': 'Rua da Panificadora, 12',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10262,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-07-22T21:40:00.000Z',
        'ShippedDate': '1996-07-25T19:10:00.000Z',
        'Freight': 48.29,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10263,
        'CustomerID': 'ERNSH',
        'OrderDate': '1996-07-23T00:10:00.000Z',
        'ShippedDate': '1996-07-31T22:50:00.000Z',
        'Freight': 146.06,
        'ShipName': 'Ernst Handel',
        'ShipAddress': 'Kirchgasse 6',
        'ShipCity': 'Graz',
        'ShipRegion': null,
        'ShipCountry': 'Austria'
    },
    {
        'OrderID': 10264,
        'CustomerID': 'FOLKO',
        'OrderDate': '1996-07-24T20:10:00.000Z',
        'ShippedDate': '1996-08-23T11:40:00.000Z',
        'Freight': 3.67,
        'ShipName': 'Folk och fä HB',
        'ShipAddress': 'Åkergatan 24',
        'ShipCity': 'Bräcke',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10265,
        'CustomerID': 'BLONP',
        'OrderDate': '1996-07-25T23:50:00.000Z',
        'ShippedDate': '1996-08-12T02:10:00.000Z',
        'Freight': 55.28,
        'ShipName': 'Blondel père et fils',
        'ShipAddress': '24, place Kléber',
        'ShipCity': 'Strasbourg',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10266,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-07-26T03:10:00.000Z',
        'ShippedDate': '1996-07-31T01:50:00.000Z',
        'Freight': 25.73,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
    {
        'OrderID': 10267,
        'CustomerID': 'FRANK',
        'OrderDate': '1996-07-29T04:10:00.000Z',
        'ShippedDate': '1996-08-06T17:20:00.000Z',
        'Freight': 208.58,
        'ShipName': 'Frankenversand',
        'ShipAddress': 'Berliner Platz 43',
        'ShipCity': 'München',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10268,
        'CustomerID': 'GROSR',
        'OrderDate': '1996-07-30T01:20:00.000Z',
        'ShippedDate': '1996-08-02T03:40:00.000Z',
        'Freight': 66.29,
        'ShipName': 'GROSELLA-Restaurante',
        'ShipAddress': '5ª Ave. Los Palos Grandes',
        'ShipCity': 'Caracas',
        'ShipRegion': 'DF',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10269,
        'CustomerID': 'WHITC',
        'OrderDate': '1996-07-31T05:10:00.000Z',
        'ShippedDate': '1996-08-09T07:10:00.000Z',
        'Freight': 4.56,
        'ShipName': 'White Clover Markets',
        'ShipAddress': '1029 - 12th Ave. S.',
        'ShipCity': 'Seattle',
        'ShipRegion': 'WA',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10270,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-08-01T09:10:00.000Z',
        'ShippedDate': '1996-08-02T11:10:00.000Z',
        'Freight': 136.54,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
    {
        'OrderID': 10271,
        'CustomerID': 'SPLIR',
        'OrderDate': '1996-08-01T13:10:00.000Z',
        'ShippedDate': '1996-08-30T15:10:00.000Z',
        'Freight': 4.54,
        'ShipName': 'Split Rail Beer & Ale',
        'ShipAddress': 'P.O. Box 555',
        'ShipCity': 'Lander',
        'ShipRegion': 'WY',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10272,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-08-02T17:10:00.000Z',
        'ShippedDate': '1996-08-06T19:10:00.000Z',
        'Freight': 98.03,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10273,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-05T21:10:00.000Z',
        'ShippedDate': '1996-08-12T23:10:00.000Z',
        'Freight': 76.07,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10274,
        'CustomerID': 'VINET',
        'OrderDate': '1996-08-06T02:10:00.000Z',
        'ShippedDate': '1996-08-16T04:10:00.000Z',
        'Freight': 6.01,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10275,
        'CustomerID': 'MAGAA',
        'OrderDate': '1996-08-07T06:10:00.000Z',
        'ShippedDate': '1996-08-09T08:10:00.000Z',
        'Freight': 26.93,
        'ShipName': 'Magazzini Alimentari Riuniti',
        'ShipAddress': 'Via Ludovico il Moro 22',
        'ShipCity': 'Bergamo',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10276,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-08-08T10:10:00.000Z',
        'ShippedDate': '1996-08-14T12:10:00.000Z',
        'Freight': 13.84,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10277,
        'CustomerID': 'MORGK',
        'OrderDate': '1996-08-09T14:10:00.000Z',
        'ShippedDate': '1996-08-13T16:10:00.000Z',
        'Freight': 125.77,
        'ShipName': 'Morgenstern Gesundkost',
        'ShipAddress': 'Heerstr. 22',
        'ShipCity': 'Leipzig',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10278,
        'CustomerID': 'BERGS',
        'OrderDate': '1996-08-12T18:10:00.000Z',
        'ShippedDate': '1996-08-16T20:10:00.000Z',
        'Freight': 92.69,
        'ShipName': 'Berglunds snabbköp',
        'ShipAddress': 'Berguvsvägen  8',
        'ShipCity': 'Luleå',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10279,
        'CustomerID': 'LEHMS',
        'OrderDate': '1996-08-13T22:10:00.000Z',
        'ShippedDate': '1996-08-16T02:10:00.000Z',
        'Freight': 25.83,
        'ShipName': 'Lehmanns Marktstand',
        'ShipAddress': 'Magazinweg 7',
        'ShipCity': 'Frankfurt a.M.',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10280,
        'CustomerID': 'BERGS',
        'OrderDate': '1996-08-14T01:40:00.000Z',
        'ShippedDate': '1996-09-12T02:40:00.000Z',
        'Freight': 8.98,
        'ShipName': 'Berglunds snabbköp',
        'ShipAddress': 'Berguvsvägen  8',
        'ShipCity': 'Luleå',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10281,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-08-14T03:40:00.000Z',
        'ShippedDate': '1996-08-21T04:40:00.000Z',
        'Freight': 2.94,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10282,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-08-15T05:40:00.000Z',
        'ShippedDate': '1996-08-21T06:40:00.000Z',
        'Freight': 12.69,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10283,
        'CustomerID': 'LILAS',
        'OrderDate': '1996-08-16T07:40:00.000Z',
        'ShippedDate': '1996-08-23T08:40:00.000Z',
        'Freight': 84.81,
        'ShipName': 'LILA-Supermercado',
        'ShipAddress': 'Carrera 52 con Ave. Bolívar #65-98 Llano Largo',
        'ShipCity': 'Barquisimeto',
        'ShipRegion': 'Lara',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10284,
        'CustomerID': 'LEHMS',
        'OrderDate': '1996-08-19T09:40:00.000Z',
        'ShippedDate': '1996-08-27T10:40:00.000Z',
        'Freight': 76.56,
        'ShipName': 'Lehmanns Marktstand',
        'ShipAddress': 'Magazinweg 7',
        'ShipCity': 'Frankfurt a.M.',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10285,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-20T11:40:00.000Z',
        'ShippedDate': '1996-08-26T12:40:00.000Z',
        'Freight': 76.83,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10286,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-21T01:50:00.000Z',
        'ShippedDate': '1996-08-30T02:50:00.000Z',
        'Freight': 229.24,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10287,
        'CustomerID': 'RICAR',
        'OrderDate': '1996-08-22T03:50:00.000Z',
        'ShippedDate': '1996-08-28T04:50:00.000Z',
        'Freight': 12.76,
        'ShipName': 'Ricardo Adocicados',
        'ShipAddress': 'Av. Copacabana, 267',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10288,
        'CustomerID': 'REGGC',
        'OrderDate': '1996-08-23T05:50:00.000Z',
        'ShippedDate': '1996-09-03T06:50:00.000Z',
        'Freight': 7.45,
        'ShipName': 'Reggiani Caseifici',
        'ShipAddress': 'Strada Provinciale 124',
        'ShipCity': 'Reggio Emilia',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10289,
        'CustomerID': 'BSBEV',
        'OrderDate': '1996-08-26T07:50:00.000Z',
        'ShippedDate': '1996-08-28T08:50:00.000Z',
        'Freight': 22.77,
        'ShipName': 'B\'s Beverages',
        'ShipAddress': 'Fauntleroy Circus',
        'ShipCity': 'London',
        'ShipRegion': null,
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10290,
        'CustomerID': 'COMMI',
        'OrderDate': '1996-08-27T09:50:00.000Z',
        'ShippedDate': '1996-09-03T10:50:00.000Z',
        'Freight': 79.7,
        'ShipName': 'Comércio Mineiro',
        'ShipAddress': 'Av. dos Lusíadas, 23',
        'ShipCity': 'Sao Paulo',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10291,
        'CustomerID': 'QUEDE',
        'OrderDate': '1996-08-27T11:50:00.000Z',
        'ShippedDate': '1996-09-04T12:50:00.000Z',
        'Freight': 6.4,
        'ShipName': 'Que Delícia',
        'ShipAddress': 'Rua da Panificadora, 12',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10292,
        'CustomerID': 'TRADH',
        'OrderDate': '1996-08-28T01:10:00.000Z',
        'ShippedDate': '1996-09-02T02:10:00.000Z',
        'Freight': 1.35,
        'ShipName': 'Tradiçao Hipermercados',
        'ShipAddress': 'Av. Inês de Castro, 414',
        'ShipCity': 'Sao Paulo',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10293,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-08-29T03:10:00.000Z',
        'ShippedDate': '1996-09-11T04:10:00.000Z',
        'Freight': 21.18,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10294,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-08-30T05:10:00.000Z',
        'ShippedDate': '1996-09-05T06:10:00.000Z',
        'Freight': 147.26,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10295,
        'CustomerID': 'VINET',
        'OrderDate': '1996-09-02T07:10:00.000Z',
        'ShippedDate': '1996-09-10T08:10:00.000Z',
        'Freight': 1.15,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10296,
        'CustomerID': 'LILAS',
        'OrderDate': '1996-09-03T09:10:00.000Z',
        'ShippedDate': '1996-09-11T10:10:00.000Z',
        'Freight': 0.12,
        'ShipName': 'LILA-Supermercado',
        'ShipAddress': 'Carrera 52 con Ave. Bolívar #65-98 Llano Largo',
        'ShipCity': 'Barquisimeto',
        'ShipRegion': 'Lara',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10297,
        'CustomerID': 'BLONP',
        'OrderDate': '1996-09-04T11:10:00.000Z',
        'ShippedDate': '1996-09-10T12:10:00.000Z',
        'Freight': 5.74,
        'ShipName': 'Blondel père et fils',
        'ShipAddress': '24, place Kléber',
        'ShipCity': 'Strasbourg',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10298,
        'CustomerID': 'HUNGO',
        'OrderDate': '1996-09-05T01:10:00.000Z',
        'ShippedDate': '1996-09-11T02:20:00.000Z',
        'Freight': 168.22,
        'ShipName': 'Hungry Owl All-Night Grocers',
        'ShipAddress': '8 Johnstown Road',
        'ShipCity': 'Cork',
        'ShipRegion': 'Co. Cork',
        'ShipCountry': 'Ireland'
    },
    {
        'OrderID': 10299,
        'CustomerID': 'RICAR',
        'OrderDate': '1996-09-06T03:20:00.000Z',
        'ShippedDate': '1996-09-13T04:20:00.000Z',
        'Freight': 29.76,
        'ShipName': 'Ricardo Adocicados',
        'ShipAddress': 'Av. Copacabana, 267',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10300,
        'CustomerID': 'MAGAA',
        'OrderDate': '1996-09-09T05:20:00.000Z',
        'ShippedDate': '1996-09-18T06:20:00.000Z',
        'Freight': 17.68,
        'ShipName': 'Magazzini Alimentari Riuniti',
        'ShipAddress': 'Via Ludovico il Moro 22',
        'ShipCity': 'Bergamo',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10301,
        'CustomerID': 'WANDK',
        'OrderDate': '1996-09-09T07:20:00.000Z',
        'ShippedDate': '1996-09-17T08:20:00.000Z',
        'Freight': 45.08,
        'ShipName': 'Die Wandernde Kuh',
        'ShipAddress': 'Adenauerallee 900',
        'ShipCity': 'Stuttgart',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10302,
        'CustomerID': 'SUPRD',
        'OrderDate': '1996-09-10T09:20:00.000Z',
        'ShippedDate': '1996-10-09T10:20:00.000Z',
        'Freight': 6.27,
        'ShipName': 'Suprêmes délices',
        'ShipAddress': 'Boulevard Tirou, 255',
        'ShipCity': 'Charleroi',
        'ShipRegion': null,
        'ShipCountry': 'Belgium'
    },
    {
        'OrderID': 10303,
        'CustomerID': 'GODOS',
        'OrderDate': '1996-09-11T11:20:00.000Z',
        'ShippedDate': '1996-09-18T12:20:00.000Z',
        'Freight': 107.83,
        'ShipName': 'Godos Cocina Típica',
        'ShipAddress': 'C/ Romero, 33',
        'ShipCity': 'Sevilla',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10304,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-09-12T00:10:00.000Z',
        'ShippedDate': '1996-09-17T01:20:00.000Z',
        'Freight': 63.79,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10305,
        'CustomerID': 'OLDWO',
        'OrderDate': '1996-09-13T01:20:00.000Z',
        'ShippedDate': '1996-10-09T02:20:00.000Z',
        'Freight': 257.62,
        'ShipName': 'Old World Delicatessen',
        'ShipAddress': '2743 Bering St.',
        'ShipCity': 'Anchorage',
        'ShipRegion': 'AK',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10306,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-09-16T03:20:00.000Z',
        'ShippedDate': '1996-09-23T04:20:00.000Z',
        'Freight': 7.56,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10307,
        'CustomerID': 'LONEP',
        'OrderDate': '1996-09-17T05:20:00.000Z',
        'ShippedDate': '1996-09-25T06:20:00.000Z',
        'Freight': 0.56,
        'ShipName': 'Lonesome Pine Restaurant',
        'ShipAddress': '89 Chiaroscuro Rd.',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10308,
        'CustomerID': 'ANATR',
        'OrderDate': '1996-09-18T07:20:00.000Z',
        'ShippedDate': '1996-09-24T08:20:00.000Z',
        'Freight': 1.61,
        'ShipName': 'Ana Trujillo Emparedados y helados',
        'ShipAddress': 'Avda. de la Constitución 2222',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10309,
        'CustomerID': 'HUNGO',
        'OrderDate': '1996-09-19T09:20:00.000Z',
        'ShippedDate': '1996-10-23T10:20:00.000Z',
        'Freight': 47.3,
        'ShipName': 'Hungry Owl All-Night Grocers',
        'ShipAddress': '8 Johnstown Road',
        'ShipCity': 'Cork',
        'ShipRegion': 'Co. Cork',
        'ShipCountry': 'Ireland'
    },
    {
        'OrderID': 10310,
        'CustomerID': 'THEBI',
        'OrderDate': '1996-09-20T11:20:00.000Z',
        'ShippedDate': '1996-09-27T12:20:00.000Z',
        'Freight': 17.52,
        'ShipName': 'The Big Cheese',
        'ShipAddress': '89 Jefferson Way Suite 2',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10311,
        'CustomerID': 'DUMON',
        'OrderDate': '1996-09-20T13:20:00.000Z',
        'ShippedDate': '1996-09-26T14:20:00.000Z',
        'Freight': 24.69,
        'ShipName': 'Du monde entier',
        'ShipAddress': '67, rue des Cinquante Otages',
        'ShipCity': 'Nantes',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10312,
        'CustomerID': 'WANDK',
        'OrderDate': '1996-09-23T15:20:00.000Z',
        'ShippedDate': '1996-10-03T16:20:00.000Z',
        'Freight': 40.26,
        'ShipName': 'Die Wandernde Kuh',
        'ShipAddress': 'Adenauerallee 900',
        'ShipCity': 'Stuttgart',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10313,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-09-24T17:20:00.000Z',
        'ShippedDate': '1996-10-04T18:20:00.000Z',
        'Freight': 1.96,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10314,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-09-25T19:20:00.000Z',
        'ShippedDate': '1996-10-04T20:20:00.000Z',
        'Freight': 74.16,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10315,
        'CustomerID': 'ISLAT',
        'OrderDate': '1996-09-26T21:20:00.000Z',
        'ShippedDate': '1996-10-03T22:20:00.000Z',
        'Freight': 41.76,
        'ShipName': 'Island Trading',
        'ShipAddress': 'Garden House Crowther Way',
        'ShipCity': 'Cowes',
        'ShipRegion': 'Isle of Wight',
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10316,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-09-27T23:20:00.000Z',
        'ShippedDate': '1996-10-08T00:30:00.000Z',
        'Freight': 150.15,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10317,
        'CustomerID': 'LONEP',
        'OrderDate': '1996-09-30T01:30:00.000Z',
        'ShippedDate': '1996-10-10T02:30:00.000Z',
        'Freight': 12.69,
        'ShipName': 'Lonesome Pine Restaurant',
        'ShipAddress': '89 Chiaroscuro Rd.',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10318,
        'CustomerID': 'ISLAT',
        'OrderDate': '1996-10-01T03:30:00.000Z',
        'ShippedDate': '1996-10-04T03:30:00.000Z',
        'Freight': 4.73,
        'ShipName': 'Island Trading',
        'ShipAddress': 'Garden House Crowther Way',
        'ShipCity': 'Cowes',
        'ShipRegion': 'Isle of Wight',
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10319,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-10-02T04:30:00.000Z',
        'ShippedDate': '1996-10-11T05:30:00.000Z',
        'Freight': 64.5,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10320,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-10-03T06:30:00.000Z',
        'ShippedDate': '1996-10-18T07:30:00.000Z',
        'Freight': 34.57,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
]
export let data: object[] = [
    {
        'OrderID': 10248,
        'CustomerID': 'VINET',
        'OrderDate': '1996-07-04T10:10:00.000Z',
        'ShippedDate': '1996-07-16T12:20:00.000Z',
        'Freight': 32.38,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10249,
        'CustomerID': 'TOMSP',
        'OrderDate': '1996-07-05T12:20:00.000Z',
        'ShippedDate': '1996-07-10T13:20:00.000Z',
        'Freight': 11.61,
        'ShipName': 'Toms Spezialitäten',
        'ShipAddress': 'Luisenstr. 48',
        'ShipCity': 'Münster',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10250,
        'CustomerID': 'HANAR',
        'OrderDate': '1996-07-08T08:40:00.000Z',
        'ShippedDate': '1996-07-12T07:50:00.000Z',
        'Freight': 65.83,
        'ShipName': 'Hanari Carnes',
        'ShipAddress': 'Rua do Paço, 67',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10251,
        'CustomerID': 'VICTE',
        'OrderDate': '1996-07-08T07:50:00.000Z',
        'ShippedDate': '1996-07-15T15:50:00.000Z',
        'Freight': 41.34,
        'ShipName': 'Victuailles en stock',
        'ShipAddress': '2, rue du Commerce',
        'ShipCity': 'Lyon',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10252,
        'CustomerID': 'SUPRD',
        'OrderDate': '1996-07-09T12:05:00.000Z',
        'ShippedDate': '1996-07-11T17:30:00.000Z',
        'Freight': 51.3,
        'ShipName': 'Suprêmes délices',
        'ShipAddress': 'Boulevard Tirou, 255',
        'ShipCity': 'Charleroi',
        'ShipRegion': null,
        'ShipCountry': 'Belgium'
    },
    {
        'OrderID': 10253,
        'CustomerID': 'HANAR',
        'OrderDate': '1996-07-10T11:20:00.000Z',
        'ShippedDate': '1996-07-16T10:10:00.000Z',
        'Freight': 58.17,
        'ShipName': 'Hanari Carnes',
        'ShipAddress': 'Rua do Paço, 67',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10254,
        'CustomerID': 'CHOPS',
        'OrderDate': '1996-07-11T10:00.00.000Z',
        'ShippedDate': '1996-07-23T20:40:00.000Z',
        'Freight': 22.98,
        'ShipName': 'Chop-suey Chinese',
        'ShipAddress': 'Hauptstr. 31',
        'ShipCity': 'Bern',
        'ShipRegion': null,
        'ShipCountry': 'Switzerland'
    },
    {
        'OrderID': 10255,
        'CustomerID': 'RICSU',
        'OrderDate': '1996-07-12T10:40:00.000Z',
        'ShippedDate': '1996-07-15T05:40:00.000Z',
        'Freight': 148.33,
        'ShipName': 'Richter Supermarkt',
        'ShipAddress': 'Starenweg 5',
        'ShipCity': 'Genève',
        'ShipRegion': null,
        'ShipCountry': 'Switzerland'
    },
    {
        'OrderID': 10256,
        'CustomerID': 'WELLI',
        'OrderDate': '1996-07-15T20:50:00.000Z',
        'ShippedDate': '1996-07-17T21:50:00.000Z',
        'Freight': 13.97,
        'ShipName': 'Wellington Importadora',
        'ShipAddress': 'Rua do Mercado, 12',
        'ShipCity': 'Resende',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10257,
        'CustomerID': 'HILAA',
        'OrderDate': '1996-07-16T03:20:00.000Z',
        'ShippedDate': '1996-07-22T14:40:00.000Z',
        'Freight': 81.91,
        'ShipName': 'HILARION-Abastos',
        'ShipAddress': 'Carrera 22 con Ave. Carlos Soublette #8-35',
        'ShipCity': 'San Cristóbal',
        'ShipRegion': 'Táchira',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10258,
        'CustomerID': 'ERNSH',
        'OrderDate': '1996-07-17T18:30:00.000Z',
        'ShippedDate': '1996-07-23T14:50:00.000Z',
        'Freight': 140.51,
        'ShipName': 'Ernst Handel',
        'ShipAddress': 'Kirchgasse 6',
        'ShipCity': 'Graz',
        'ShipRegion': null,
        'ShipCountry': 'Austria'
    },
    {
        'OrderID': 10259,
        'CustomerID': 'CENTC',
        'OrderDate': '1996-07-18T01:20:00.000Z',
        'ShippedDate': '1996-07-25T16:20:00.000Z',
        'Freight': 3.25,
        'ShipName': 'Centro comercial Moctezuma',
        'ShipAddress': 'Sierras de Granada 9993',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10260,
        'CustomerID': 'OTTIK',
        'OrderDate': '1996-07-19T11:20:00.000Z',
        'ShippedDate': '1996-07-29T03:10:00.000Z',
        'Freight': 55.09,
        'ShipName': 'Ottilies Käseladen',
        'ShipAddress': 'Mehrheimerstr. 369',
        'ShipCity': 'Köln',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10261,
        'CustomerID': 'QUEDE',
        'OrderDate': '1996-07-19T18:30:00.000Z',
        'ShippedDate': '1996-07-30T23:10:00.000Z',
        'Freight': 3.05,
        'ShipName': 'Que Delícia',
        'ShipAddress': 'Rua da Panificadora, 12',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10262,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-07-22T21:40:00.000Z',
        'ShippedDate': '1996-07-25T19:10:00.000Z',
        'Freight': 48.29,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10263,
        'CustomerID': 'ERNSH',
        'OrderDate': '1996-07-23T00:10:00.000Z',
        'ShippedDate': '1996-07-31T22:50:00.000Z',
        'Freight': 146.06,
        'ShipName': 'Ernst Handel',
        'ShipAddress': 'Kirchgasse 6',
        'ShipCity': 'Graz',
        'ShipRegion': null,
        'ShipCountry': 'Austria'
    },
    {
        'OrderID': 10264,
        'CustomerID': 'FOLKO',
        'OrderDate': '1996-07-24T20:10:00.000Z',
        'ShippedDate': '1996-08-23T11:40:00.000Z',
        'Freight': 3.67,
        'ShipName': 'Folk och fä HB',
        'ShipAddress': 'Åkergatan 24',
        'ShipCity': 'Bräcke',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10265,
        'CustomerID': 'BLONP',
        'OrderDate': '1996-07-25T23:50:00.000Z',
        'ShippedDate': '1996-08-12T02:10:00.000Z',
        'Freight': 55.28,
        'ShipName': 'Blondel père et fils',
        'ShipAddress': '24, place Kléber',
        'ShipCity': 'Strasbourg',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10266,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-07-26T03:10:00.000Z',
        'ShippedDate': '1996-07-31T01:50:00.000Z',
        'Freight': 25.73,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
    {
        'OrderID': 10267,
        'CustomerID': 'FRANK',
        'OrderDate': '1996-07-29T04:10:00.000Z',
        'ShippedDate': '1996-08-06T17:20:00.000Z',
        'Freight': 208.58,
        'ShipName': 'Frankenversand',
        'ShipAddress': 'Berliner Platz 43',
        'ShipCity': 'München',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10268,
        'CustomerID': 'GROSR',
        'OrderDate': '1996-07-30T01:20:00.000Z',
        'ShippedDate': '1996-08-02T03:40:00.000Z',
        'Freight': 66.29,
        'ShipName': 'GROSELLA-Restaurante',
        'ShipAddress': '5ª Ave. Los Palos Grandes',
        'ShipCity': 'Caracas',
        'ShipRegion': 'DF',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10269,
        'CustomerID': 'WHITC',
        'OrderDate': '1996-07-31T05:10:00.000Z',
        'ShippedDate': '1996-08-09T07:10:00.000Z',
        'Freight': 4.56,
        'ShipName': 'White Clover Markets',
        'ShipAddress': '1029 - 12th Ave. S.',
        'ShipCity': 'Seattle',
        'ShipRegion': 'WA',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10270,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-08-01T09:10:00.000Z',
        'ShippedDate': '1996-08-02T11:10:00.000Z',
        'Freight': 136.54,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
    {
        'OrderID': 10271,
        'CustomerID': 'SPLIR',
        'OrderDate': '1996-08-01T13:10:00.000Z',
        'ShippedDate': '1996-08-30T15:10:00.000Z',
        'Freight': 4.54,
        'ShipName': 'Split Rail Beer & Ale',
        'ShipAddress': 'P.O. Box 555',
        'ShipCity': 'Lander',
        'ShipRegion': 'WY',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10272,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-08-02T17:10:00.000Z',
        'ShippedDate': '1996-08-06T19:10:00.000Z',
        'Freight': 98.03,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10273,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-05T21:10:00.000Z',
        'ShippedDate': '1996-08-12T23:10:00.000Z',
        'Freight': 76.07,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10274,
        'CustomerID': 'VINET',
        'OrderDate': '1996-08-06T02:10:00.000Z',
        'ShippedDate': '1996-08-16T04:10:00.000Z',
        'Freight': 6.01,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10275,
        'CustomerID': 'MAGAA',
        'OrderDate': '1996-08-07T06:10:00.000Z',
        'ShippedDate': '1996-08-09T08:10:00.000Z',
        'Freight': 26.93,
        'ShipName': 'Magazzini Alimentari Riuniti',
        'ShipAddress': 'Via Ludovico il Moro 22',
        'ShipCity': 'Bergamo',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10276,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-08-08T10:10:00.000Z',
        'ShippedDate': '1996-08-14T12:10:00.000Z',
        'Freight': 13.84,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10277,
        'CustomerID': 'MORGK',
        'OrderDate': '1996-08-09T14:10:00.000Z',
        'ShippedDate': '1996-08-13T16:10:00.000Z',
        'Freight': 125.77,
        'ShipName': 'Morgenstern Gesundkost',
        'ShipAddress': 'Heerstr. 22',
        'ShipCity': 'Leipzig',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10278,
        'CustomerID': 'BERGS',
        'OrderDate': '1996-08-12T18:10:00.000Z',
        'ShippedDate': '1996-08-16T20:10:00.000Z',
        'Freight': 92.69,
        'ShipName': 'Berglunds snabbköp',
        'ShipAddress': 'Berguvsvägen  8',
        'ShipCity': 'Luleå',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10279,
        'CustomerID': 'LEHMS',
        'OrderDate': '1996-08-13T22:10:00.000Z',
        'ShippedDate': '1996-08-16T02:10:00.000Z',
        'Freight': 25.83,
        'ShipName': 'Lehmanns Marktstand',
        'ShipAddress': 'Magazinweg 7',
        'ShipCity': 'Frankfurt a.M.',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10280,
        'CustomerID': 'BERGS',
        'OrderDate': '1996-08-14T01:40:00.000Z',
        'ShippedDate': '1996-09-12T02:40:00.000Z',
        'Freight': 8.98,
        'ShipName': 'Berglunds snabbköp',
        'ShipAddress': 'Berguvsvägen  8',
        'ShipCity': 'Luleå',
        'ShipRegion': null,
        'ShipCountry': 'Sweden'
    },
    {
        'OrderID': 10281,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-08-14T03:40:00.000Z',
        'ShippedDate': '1996-08-21T04:40:00.000Z',
        'Freight': 2.94,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10282,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-08-15T05:40:00.000Z',
        'ShippedDate': '1996-08-21T06:40:00.000Z',
        'Freight': 12.69,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10283,
        'CustomerID': 'LILAS',
        'OrderDate': '1996-08-16T07:40:00.000Z',
        'ShippedDate': '1996-08-23T08:40:00.000Z',
        'Freight': 84.81,
        'ShipName': 'LILA-Supermercado',
        'ShipAddress': 'Carrera 52 con Ave. Bolívar #65-98 Llano Largo',
        'ShipCity': 'Barquisimeto',
        'ShipRegion': 'Lara',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10284,
        'CustomerID': 'LEHMS',
        'OrderDate': '1996-08-19T09:40:00.000Z',
        'ShippedDate': '1996-08-27T10:40:00.000Z',
        'Freight': 76.56,
        'ShipName': 'Lehmanns Marktstand',
        'ShipAddress': 'Magazinweg 7',
        'ShipCity': 'Frankfurt a.M.',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10285,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-20T11:40:00.000Z',
        'ShippedDate': '1996-08-26T12:40:00.000Z',
        'Freight': 76.83,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10286,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-08-21T01:50:00.000Z',
        'ShippedDate': '1996-08-30T02:50:00.000Z',
        'Freight': 229.24,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10287,
        'CustomerID': 'RICAR',
        'OrderDate': '1996-08-22T03:50:00.000Z',
        'ShippedDate': '1996-08-28T04:50:00.000Z',
        'Freight': 12.76,
        'ShipName': 'Ricardo Adocicados',
        'ShipAddress': 'Av. Copacabana, 267',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10288,
        'CustomerID': 'REGGC',
        'OrderDate': '1996-08-23T05:50:00.000Z',
        'ShippedDate': '1996-09-03T06:50:00.000Z',
        'Freight': 7.45,
        'ShipName': 'Reggiani Caseifici',
        'ShipAddress': 'Strada Provinciale 124',
        'ShipCity': 'Reggio Emilia',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10289,
        'CustomerID': 'BSBEV',
        'OrderDate': '1996-08-26T07:50:00.000Z',
        'ShippedDate': '1996-08-28T08:50:00.000Z',
        'Freight': 22.77,
        'ShipName': 'B\'s Beverages',
        'ShipAddress': 'Fauntleroy Circus',
        'ShipCity': 'London',
        'ShipRegion': null,
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10290,
        'CustomerID': 'COMMI',
        'OrderDate': '1996-08-27T09:50:00.000Z',
        'ShippedDate': '1996-09-03T10:50:00.000Z',
        'Freight': 79.7,
        'ShipName': 'Comércio Mineiro',
        'ShipAddress': 'Av. dos Lusíadas, 23',
        'ShipCity': 'Sao Paulo',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10291,
        'CustomerID': 'QUEDE',
        'OrderDate': '1996-08-27T11:50:00.000Z',
        'ShippedDate': '1996-09-04T12:50:00.000Z',
        'Freight': 6.4,
        'ShipName': 'Que Delícia',
        'ShipAddress': 'Rua da Panificadora, 12',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10292,
        'CustomerID': 'TRADH',
        'OrderDate': '1996-08-28T01:10:00.000Z',
        'ShippedDate': '1996-09-02T02:10:00.000Z',
        'Freight': 1.35,
        'ShipName': 'Tradiçao Hipermercados',
        'ShipAddress': 'Av. Inês de Castro, 414',
        'ShipCity': 'Sao Paulo',
        'ShipRegion': 'SP',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10293,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-08-29T03:10:00.000Z',
        'ShippedDate': '1996-09-11T04:10:00.000Z',
        'Freight': 21.18,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10294,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-08-30T05:10:00.000Z',
        'ShippedDate': '1996-09-05T06:10:00.000Z',
        'Freight': 147.26,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10295,
        'CustomerID': 'VINET',
        'OrderDate': '1996-09-02T07:10:00.000Z',
        'ShippedDate': '1996-09-10T08:10:00.000Z',
        'Freight': 1.15,
        'ShipName': 'Vins et alcools Chevalier',
        'ShipAddress': '59 rue de l\'Abbaye',
        'ShipCity': 'Reims',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10296,
        'CustomerID': 'LILAS',
        'OrderDate': '1996-09-03T09:10:00.000Z',
        'ShippedDate': '1996-09-11T10:10:00.000Z',
        'Freight': 0.12,
        'ShipName': 'LILA-Supermercado',
        'ShipAddress': 'Carrera 52 con Ave. Bolívar #65-98 Llano Largo',
        'ShipCity': 'Barquisimeto',
        'ShipRegion': 'Lara',
        'ShipCountry': 'Venezuela'
    },
    {
        'OrderID': 10297,
        'CustomerID': 'BLONP',
        'OrderDate': '1996-09-04T11:10:00.000Z',
        'ShippedDate': '1996-09-10T12:10:00.000Z',
        'Freight': 5.74,
        'ShipName': 'Blondel père et fils',
        'ShipAddress': '24, place Kléber',
        'ShipCity': 'Strasbourg',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10298,
        'CustomerID': 'HUNGO',
        'OrderDate': '1996-09-05T01:10:00.000Z',
        'ShippedDate': '1996-09-11T02:20:00.000Z',
        'Freight': 168.22,
        'ShipName': 'Hungry Owl All-Night Grocers',
        'ShipAddress': '8 Johnstown Road',
        'ShipCity': 'Cork',
        'ShipRegion': 'Co. Cork',
        'ShipCountry': 'Ireland'
    },
    {
        'OrderID': 10299,
        'CustomerID': 'RICAR',
        'OrderDate': '1996-09-06T03:20:00.000Z',
        'ShippedDate': '1996-09-13T04:20:00.000Z',
        'Freight': 29.76,
        'ShipName': 'Ricardo Adocicados',
        'ShipAddress': 'Av. Copacabana, 267',
        'ShipCity': 'Rio de Janeiro',
        'ShipRegion': 'RJ',
        'ShipCountry': 'Brazil'
    },
    {
        'OrderID': 10300,
        'CustomerID': 'MAGAA',
        'OrderDate': '1996-09-09T05:20:00.000Z',
        'ShippedDate': '1996-09-18T06:20:00.000Z',
        'Freight': 17.68,
        'ShipName': 'Magazzini Alimentari Riuniti',
        'ShipAddress': 'Via Ludovico il Moro 22',
        'ShipCity': 'Bergamo',
        'ShipRegion': null,
        'ShipCountry': 'Italy'
    },
    {
        'OrderID': 10301,
        'CustomerID': 'WANDK',
        'OrderDate': '1996-09-09T07:20:00.000Z',
        'ShippedDate': '1996-09-17T08:20:00.000Z',
        'Freight': 45.08,
        'ShipName': 'Die Wandernde Kuh',
        'ShipAddress': 'Adenauerallee 900',
        'ShipCity': 'Stuttgart',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10302,
        'CustomerID': 'SUPRD',
        'OrderDate': '1996-09-10T09:20:00.000Z',
        'ShippedDate': '1996-10-09T10:20:00.000Z',
        'Freight': 6.27,
        'ShipName': 'Suprêmes délices',
        'ShipAddress': 'Boulevard Tirou, 255',
        'ShipCity': 'Charleroi',
        'ShipRegion': null,
        'ShipCountry': 'Belgium'
    },
    {
        'OrderID': 10303,
        'CustomerID': 'GODOS',
        'OrderDate': '1996-09-11T11:20:00.000Z',
        'ShippedDate': '1996-09-18T12:20:00.000Z',
        'Freight': 107.83,
        'ShipName': 'Godos Cocina Típica',
        'ShipAddress': 'C/ Romero, 33',
        'ShipCity': 'Sevilla',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10304,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-09-12T00:10:00.000Z',
        'ShippedDate': '1996-09-17T01:20:00.000Z',
        'Freight': 63.79,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10305,
        'CustomerID': 'OLDWO',
        'OrderDate': '1996-09-13T01:20:00.000Z',
        'ShippedDate': '1996-10-09T02:20:00.000Z',
        'Freight': 257.62,
        'ShipName': 'Old World Delicatessen',
        'ShipAddress': '2743 Bering St.',
        'ShipCity': 'Anchorage',
        'ShipRegion': 'AK',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10306,
        'CustomerID': 'ROMEY',
        'OrderDate': '1996-09-16T03:20:00.000Z',
        'ShippedDate': '1996-09-23T04:20:00.000Z',
        'Freight': 7.56,
        'ShipName': 'Romero y tomillo',
        'ShipAddress': 'Gran Vía, 1',
        'ShipCity': 'Madrid',
        'ShipRegion': null,
        'ShipCountry': 'Spain'
    },
    {
        'OrderID': 10307,
        'CustomerID': 'LONEP',
        'OrderDate': '1996-09-17T05:20:00.000Z',
        'ShippedDate': '1996-09-25T06:20:00.000Z',
        'Freight': 0.56,
        'ShipName': 'Lonesome Pine Restaurant',
        'ShipAddress': '89 Chiaroscuro Rd.',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10308,
        'CustomerID': 'ANATR',
        'OrderDate': '1996-09-18T07:20:00.000Z',
        'ShippedDate': '1996-09-24T08:20:00.000Z',
        'Freight': 1.61,
        'ShipName': 'Ana Trujillo Emparedados y helados',
        'ShipAddress': 'Avda. de la Constitución 2222',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10309,
        'CustomerID': 'HUNGO',
        'OrderDate': '1996-09-19T09:20:00.000Z',
        'ShippedDate': '1996-10-23T10:20:00.000Z',
        'Freight': 47.3,
        'ShipName': 'Hungry Owl All-Night Grocers',
        'ShipAddress': '8 Johnstown Road',
        'ShipCity': 'Cork',
        'ShipRegion': 'Co. Cork',
        'ShipCountry': 'Ireland'
    },
    {
        'OrderID': 10310,
        'CustomerID': 'THEBI',
        'OrderDate': '1996-09-20T11:20:00.000Z',
        'ShippedDate': '1996-09-27T12:20:00.000Z',
        'Freight': 17.52,
        'ShipName': 'The Big Cheese',
        'ShipAddress': '89 Jefferson Way Suite 2',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10311,
        'CustomerID': 'DUMON',
        'OrderDate': '1996-09-20T13:20:00.000Z',
        'ShippedDate': '1996-09-26T14:20:00.000Z',
        'Freight': 24.69,
        'ShipName': 'Du monde entier',
        'ShipAddress': '67, rue des Cinquante Otages',
        'ShipCity': 'Nantes',
        'ShipRegion': null,
        'ShipCountry': 'France'
    },
    {
        'OrderID': 10312,
        'CustomerID': 'WANDK',
        'OrderDate': '1996-09-23T15:20:00.000Z',
        'ShippedDate': '1996-10-03T16:20:00.000Z',
        'Freight': 40.26,
        'ShipName': 'Die Wandernde Kuh',
        'ShipAddress': 'Adenauerallee 900',
        'ShipCity': 'Stuttgart',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10313,
        'CustomerID': 'QUICK',
        'OrderDate': '1996-09-24T17:20:00.000Z',
        'ShippedDate': '1996-10-04T18:20:00.000Z',
        'Freight': 1.96,
        'ShipName': 'QUICK-Stop',
        'ShipAddress': 'Taucherstraße 10',
        'ShipCity': 'Cunewalde',
        'ShipRegion': null,
        'ShipCountry': 'Germany'
    },
    {
        'OrderID': 10314,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-09-25T19:20:00.000Z',
        'ShippedDate': '1996-10-04T20:20:00.000Z',
        'Freight': 74.16,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10315,
        'CustomerID': 'ISLAT',
        'OrderDate': '1996-09-26T21:20:00.000Z',
        'ShippedDate': '1996-10-03T22:20:00.000Z',
        'Freight': 41.76,
        'ShipName': 'Island Trading',
        'ShipAddress': 'Garden House Crowther Way',
        'ShipCity': 'Cowes',
        'ShipRegion': 'Isle of Wight',
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10316,
        'CustomerID': 'RATTC',
        'OrderDate': '1996-09-27T23:20:00.000Z',
        'ShippedDate': '1996-10-08T00:30:00.000Z',
        'Freight': 150.15,
        'ShipName': 'Rattlesnake Canyon Grocery',
        'ShipAddress': '2817 Milton Dr.',
        'ShipCity': 'Albuquerque',
        'ShipRegion': 'NM',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10317,
        'CustomerID': 'LONEP',
        'OrderDate': '1996-09-30T01:30:00.000Z',
        'ShippedDate': '1996-10-10T02:30:00.000Z',
        'Freight': 12.69,
        'ShipName': 'Lonesome Pine Restaurant',
        'ShipAddress': '89 Chiaroscuro Rd.',
        'ShipCity': 'Portland',
        'ShipRegion': 'OR',
        'ShipCountry': 'USA'
    },
    {
        'OrderID': 10318,
        'CustomerID': 'ISLAT',
        'OrderDate': '1996-10-01T03:30:00.000Z',
        'ShippedDate': '1996-10-04T03:30:00.000Z',
        'Freight': 4.73,
        'ShipName': 'Island Trading',
        'ShipAddress': 'Garden House Crowther Way',
        'ShipCity': 'Cowes',
        'ShipRegion': 'Isle of Wight',
        'ShipCountry': 'UK'
    },
    {
        'OrderID': 10319,
        'CustomerID': 'TORTU',
        'OrderDate': '1996-10-02T04:30:00.000Z',
        'ShippedDate': '1996-10-11T05:30:00.000Z',
        'Freight': 64.5,
        'ShipName': 'Tortuga Restaurante',
        'ShipAddress': 'Avda. Azteca 123',
        'ShipCity': 'México D.F.',
        'ShipRegion': null,
        'ShipCountry': 'Mexico'
    },
    {
        'OrderID': 10320,
        'CustomerID': 'WARTH',
        'OrderDate': '1996-10-03T06:30:00.000Z',
        'ShippedDate': '1996-10-18T07:30:00.000Z',
        'Freight': 34.57,
        'ShipName': 'Wartian Herkku',
        'ShipAddress': 'Torikatu 38',
        'ShipCity': 'Oulu',
        'ShipRegion': null,
        'ShipCountry': 'Finland'
    },
]

Adding header and footer in Angular Grid component

6 Sep 202215 minutes to read

You can customize text, page number, line, page size and changing orientation in header and footer.

You can add text either in Header or Footer of exported PDF document using pdfExportProperties.

const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Text',
                value: "Northwind Traders",
                position: { x: 0, y: 50 },
                style: { textBrushColor: '#000000', fontSize: 13 }
            },
        ]
    }

you can add line either in Header or Footer of the exported PDF document.

Supported line styles:

  • Dash
  • Dot
  • DashDot
  • DashDotDot
  • Solid
const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Line',
                style: { penColor: '#000080', penSize: 2, dashStyle: 'Solid' },
                points: { x1: 0, y1: 4, x2: 685, y2: 4 }
            }
        ]
    }
}

you can add page number either in Header or Footer of exported PDF document.

Supported page number types:

  • LowerLatin - a, b, c,
  • UpperLatin - A, B, C,
  • LowerRoman - i, ii, iii,
  • UpperRoman - I, II, III,
  • Number - 1,2,3.
 const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'PageNumber',
                pageNumberType: 'Arabic',
                format: 'Page {$current} of {$total}', //optional
                position: { x: 0, y: 25 },
                style: { textBrushColor: '#ffff80', fontSize: 15, hAlign: 'Center' }
            }
        ]
    }
}

Image (Base64 string with .jpeg format) can be added in the exported document in header/footer using the pdfExportProperties.

const exportProperties: PdfExportProperties = {
    header: {
        fromTop: 0,
        height: 130,
        contents: [
            {
                type: 'Image',
                src: image,
                position: { x: 40, y: 10 },
                size: { height: 100, width: 250 },
            }
        ]
    }
}

The below code illustrates the pdf export customization.

import { Component, OnInit, ViewChild } from '@angular/core';
import { data } from './datasource';
import { GridComponent, ToolbarItems, PdfExportProperties } from '@syncfusion/ej2-angular-grids';
import { ClickEventArgs } from '@syncfusion/ej2-angular-navigations';
import { image } from './image';

@Component({
    selector: 'app-root',
    template: `<ejs-grid #grid id='Grid' [dataSource]='data' [toolbar]='toolbarOptions' height='272px'
              [allowPaging]='true' [allowPdfExport]='true' (toolbarClick)='toolbarClick($event)'>
                <e-columns>
                    <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=120></e-column>
                    <e-column field='CustomerID' headerText='Customer ID' width=150></e-column>
                    <e-column field='ShipCity' headerText='Ship City' width=150></e-column>
                    <e-column field='ShipName' headerText='Ship Name' width=150></e-column>
                </e-columns>
                </ejs-grid>`
})
export class AppComponent implements OnInit {

    public data: object[];
    public toolbarOptions: ToolbarItems[];
    @ViewChild('grid') public grid: GridComponent;

    ngOnInit(): void {
        this.data = data;
        this.toolbarOptions = ['PdfExport'];
    }

    toolbarClick(args: ClickEventArgs): void {
        if (args.item.id === 'Grid_pdfexport') { // 'Grid_pdfexport' -> Grid component id + _ + toolbar item name
            const pdfExportProperties: PdfExportProperties = {
                header: {
                    fromTop: 0,
                    height: 130,
                    contents: [
                        {
                            type: 'Image',
                            src: image,
                            position: { x: 40, y: 10 },
                            size: { height: 100, width: 250 },
                        }
                    ]
                },
                footer: {
                    fromBottom: 160,
                    height: 150,
                    contents: [
                        {
                            type: 'PageNumber',
                            pageNumberType: 'Arabic',
                            format: 'Page {$current} of {$total}',
                            position: { x: 0, y: 25 },
                            style: { textBrushColor: '#ffff80', fontSize: 15 }
                        }
                    ]
                }
            };
            this.grid.pdfExport(pdfExportProperties);
        }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { GridModule, ToolbarService, PdfExportService } from '@syncfusion/ej2-angular-grids';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        GridModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [PdfExportService, ToolbarService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Repeat column header on every page

By default, column header will be placed on the first page of the pdf document but you can display column header on every page using repeatHeader property of pdfGrid.

In the below sample, we have enabled repeatHeader property in pdfHeaderQueryCellInfo event to show the header on every page.

import { Component, OnInit, ViewChild } from '@angular/core';
import { purchaseData } from './datasource';
import { GridComponent, ToolbarItems } from '@syncfusion/ej2-angular-grids';
import { ClickEventArgs } from '@syncfusion/ej2-angular-navigations';

@Component({
    selector: 'app-root',
    template: `<ejs-grid #grid id='Grid' [dataSource]='data' [toolbar]='toolbarOptions' height='272px'
             [allowPdfExport]='true' (pdfHeaderQueryCellInfo)='pdfHeaderQueryCellInfo($event)' (toolbarClick)='toolbarClick($event)'>
                <e-columns>
                    <e-column field='OrderID' headerText='Order ID' textAlign='Right' width=120></e-column>
                    <e-column field='CustomerID' headerText='Customer ID' width=150></e-column>
                    <e-column field='Freight' headerText='Freight' width=150></e-column>
                    <e-column field='ShipName' headerText='Ship Name' width=150></e-column>
                </e-columns>
                </ejs-grid>`
})
export class AppComponent implements OnInit {

    public data: object[];
    public toolbarOptions: ToolbarItems[];
    @ViewChild('grid')
    public grid: GridComponent;

    ngOnInit(): void {
        this.data = purchaseData;
        this.toolbarOptions = ['PdfExport'];
    }

    toolbarClick(args: ClickEventArgs): void {
        if (args.item.id === 'Grid_pdfexport') {
            this.grid.pdfExport();
        }
    }

    pdfHeaderQueryCellInfo(args: any): void {
         args.cell.row.pdfGrid.repeatHeader = true;
    }

}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { GridModule, ToolbarService, PdfExportService } from '@syncfusion/ej2-angular-grids';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        GridModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [PdfExportService, ToolbarService]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);